#-*-coding:utf-8-*-

"""
ondepartable.py rassemble des fonctions
permettant de produire des ondes
par balayage de tables
"""


__date__ = "2006.02.07, 09.01.19"
__author__ = "Copyright (c) René Bastian 2002-2009 <rbastian@free.fr>"


def ondeTableMF(table, modfreq): 
    """ retourne une onde de fréquence variable selon 'modfreq' 
    par balayage de la 'table'.
    'table' : une forme d'onde (souvent sr échantillons)
    'modfreq' : un vecteur des fréquences
    En général, modfreq = _p.profil(E).

    sous 'try': la version numpy
    sous 'except' : la version numarray
    """
    
    try:
        phases = NY.cumsum(modfreq) 
        indices = NY.array(phases, int) % len(table)
        return table[indices]
    except TypeError:
        
        phases = NA.add.accumulate(modfreq)
        
        indices = phases.astype(NA.Int32) % len(table)
        return table[indices]


