#-*-coding:utf-8-*-

"""fournit quelques méthodes pour la mise en forme de profils"""

from types import IntType, LongType, FloatType, TupleType



__author__ = "Copyright (c) René Bastian <rbastian@free.fr>"
__date__ = "2006.02.04, 08.01.19, 08.02.05"


import profils as _p
import numpy


def profilnormalise(profilP, somme = 1.0):
    """un profil de durée quelconque est ramené à une duréé
    donnée par 'somme'.
    'profilP' : profil-liste avec des durées absolues;
    retourne un profil-liste.

    La présence de parties fixes m'& amené un temps à adopter le choix
    de laisser ces parties fixes en dehors du recalcul, 
    mais il faut revenir à l'intégration sans cela on
    obtient des profils amputés.
    En passant à numpy, j'ai eu des ennuis.
    21.06.04, 12.07.05, 27.07.07, 7.01.08, 13.05.08., 9.02.09

    utilisé dans ProfilBase"""
    if somme <= 0.0:
        print "profils2.profilnormalise: somme <= 0:", somme
        return None
    sm, sf = 0.0, 0.0
    for p in profilP:
        try:
            sm += p[1]
        except StandardError:
            sf += p[1][0]
    
    rapport = (somme-sf)/sm 
    
    R = []
    for a in profilP:
        if isinstance(a[1], (int, float)):
            
            p = [a[0], a[1]*rapport] + a[2:]
            R.append(p)
        elif  isinstance(a[1], tuple) and (len(a[1])==1):
            R.append([a[0], a[1][0]] + a[2:])
            
        elif isinstance(a[1], tuple) and (len(a[1]) > 1):
            print "profilnormalise:", profilP, somme
            print "profilP contient un tuple non normalisable."
        else:
            print "profils2.profilnormalise:type(a[1])", type(a[1])
    return R


