#-*-coding:utf-8-*-

"""
Le python joue des fichiers audio;
il peut être adapté à une réalisation de concert.
"""

import ossaudiodev as OSS
import sys
import os

__author__ = "Copyright (c) 2005-07 René Bastian (Wissembourg, FRANCE)"
__date__ = "2007.04.26, 09.01.11"

class Audio(object):
    """classe pour envoyer un fichier audio à la carte son.
    Fonctionne seulement s/Linux.
    La classe est extraite du module live"""
    
    def __init__(self, canaux = 2, sr = 44100, format = OSS.AFMT_S16_LE):
        """instancie une sortie stéréo.
        Inutile de faire un try, puisque ça n'ira pas ..."""
        if canaux != 2:
            print "Audio.__init__ : version stéréo uniquement"
            canaux = 2
        try:
            self.f = OSS.open("w")
        except IOError:
            s = """Audio.__init__: 
            ou bien je n'arrive pas à ouvrir l'interface audio,
            ou bien elle est déjà ouverte ... """
            print s 
            self.ossflag = False            
        else:
            self.ossflag = True
            self.f.setfmt(format)
            self.f.channels(canaux)
            self.f.speed(sr)
        
    def close(self):
        "ferme la sortie stéréo."
        try:
            self.f.close()
        except StandardError:
            print "Audio.close: erreur"

    def file(self, nom):
        """envoie le fichier son au convertisseur
        La recherche des '.wav.' permet aussi de jouer les fichiers recopiés
        par 'versionneur'.
        """
        faudio = open(nom, "rb")
        raw = faudio.read()
        faudio.close()
        if self.ossflag:
            if nom[-4:] == ".wav":
                self.f.write(raw[44:])
            elif nom[-4:] == ".raw":
                self.f.write(raw)
            elif ".wav." in nom:
                self.f.write(raw[44:])
            else:
                try:
                    self.f.write(raw)
                except StandardError:
                    print "Audio.file : ", nom, "non jouable" 
        else:
            print "ya un pépin"

def usage():
    "explique l'usage"
    s = """
    appel : python jt.py nom_du_fichier_en_format_wav_ou_raw
    Les données sont jouées en supposant qu'il s'agit d'un
    fichier stéréo/44100/16bits.
    """
    print s
    sys.exit()

def jliste(Liste):
    """
    L'usage n'est pas bien clair ...
    on pourrait ajouter la lecture d'un fichier-info
    joue la suite de noms de fichiers est developpee par les 'wildcards'
    en une liste à jouer.
    """
    
    for nom in Liste:
        n = os.stat(nom).st_size
        duree = float(n) / (44100 * 2 * 2)
        print "%10.2f %14i %s" % (duree, n, nom)
        q = raw_input("Que faire [ENTER, q, Q, n, N] ? ")
        if q in ["q", "Q"]:
            break
        elif q in ["n", "N"]:
            continue
        else:
            try:
                audio.file(nom)            
            except StandardError:
                print "C'est fini !"
                return
                
if __name__ == "__main__":
    

    audio = Audio()
    if len(sys.argv) < 2:
        usage()
    elif len(sys.argv) == 2:
        nomf = sys.argv[1]
        audio.file(nomf)
        audio.close()
    elif len(sys.argv) >= 3:
        xListe = sys.argv[1:]
        jliste(xListe)
        sys.exit()
        print xListe
        for nomf in xListe:
            print "A", nomf
            try:
                audio.file(nomf)
            except StandardError:
                print "R ---->", nomf
        audio.close()
        
    



